from machine import Pin, PWM
from time import sleep

# Configurar el pin GPIO para el LED
led_pin = Pin(0, Pin.OUT)

# Configurar los pines GPIO para los servos
servo1 = PWM(Pin(6))
servo1.freq(50)  # Establecer la frecuencia del PWM en 50 Hz

servo2 = PWM(Pin(26))
servo2.freq(50)  # Establecer la frecuencia del PWM en 50 Hz

# Función para configurar el ángulo del servo
def set_servo_angle(servo, angle):
    # Convertir el ángulo a un ciclo de trabajo entre 1 ms y 2 ms
    # 65535 / 20ms = ciclo de trabajo para 1ms
    # Ajustar el ciclo de trabajo según las especificaciones de tu servo
    duty = int(((angle / 180) * (2 - 1) + 1) * (65535 / 20))
    servo.duty_u16(duty)

try:
    while True:
        # Encender el LED
        led_pin.on()
        
        # Mover el servo 2 a 180 grados
        set_servo_angle(servo2, 180)
        sleep(0.5)  # Esperar 0.5 segundos
        
        # Mover el servo 2 a 0 grados
        set_servo_angle(servo2, 0)
        sleep(0.5)  # Esperar 0.5 segundos
        
        # Apagar el LED
        led_pin.off()
        
        # Esperar 1 segundo antes de mover el siguiente servo
        sleep(1)
        
        # Encender el LED
        led_pin.on()
        
        # Mover el servo 1 a 30 grados
        set_servo_angle(servo1, 70)
        sleep(0.5)  # Esperar 0.5 segundos
        
        # Mover el servo 1 a 0 grados
        set_servo_angle(servo1, 0)
        sleep(0.5)  # Esperar 0.5 segundos
        
        # Apagar el LED
        led_pin.off()
        
        # Esperar 1 segundo antes de repetir la secuencia
        sleep(1)
        
except KeyboardInterrupt:
    # Limpiar
    servo1.deinit()
    servo2.deinit()
