from machine import Pin, PWM
from time import sleep

# Configurar el pin GPIO para el LED
led_pin = Pin(0, Pin.OUT)

# Configurar el pin GPIO para el servo
servo = PWM(Pin(6))
servo.freq(50)  # Establecer la frecuencia del PWM en 50 Hz

# Función para configurar el ángulo del servo
def set_servo_angle(angle):
    # Convertir el ángulo a un ciclo de trabajo entre 1 ms y 2 ms
    # 65535 / 20ms = ciclo de trabajo para 1ms
    # Ajustar el ciclo de trabajo según las especificaciones de tu servo
    duty = int(((angle / 50 ) * (2 - 1) + 1) * (65535 / 20))
    servo.duty_u16(duty)

try:
    while True:
        # Encender el LED
        led_pin.on()
        # Mover el servo a 0 grados
        set_servo_angle(0)
        sleep(0.5)  # Esperar 0.5 segundos
        # Apagar el LED
        led_pin.off()
        # Mover el servo a 180 grados
        set_servo_angle(30)
        sleep(0.5)  # Esperar 0.5 segundos
        # Mover el servo a 360 grados
        set_servo_angle(30)
        sleep(0.5)  # Esperar 0.5 segundos
except KeyboardInterrupt:
    # Limpiar
    servo.deinit()
